linux/tools/testing/selftests/cpu-hotplug/on-off-test.sh
<<
>>
Prefs
   1#!/bin/bash
   2
   3SYSFS=
   4
   5prerequisite()
   6{
   7        msg="skip all tests:"
   8
   9        if [ $UID != 0 ]; then
  10                echo $msg must be run as root >&2
  11                exit 0
  12        fi
  13
  14        SYSFS=`mount -t sysfs | head -1 | awk '{ print $3 }'`
  15
  16        if [ ! -d "$SYSFS" ]; then
  17                echo $msg sysfs is not mounted >&2
  18                exit 0
  19        fi
  20
  21        if ! ls $SYSFS/devices/system/cpu/cpu* > /dev/null 2>&1; then
  22                echo $msg cpu hotplug is not supported >&2
  23                exit 0
  24        fi
  25}
  26
  27#
  28# list all hot-pluggable CPUs
  29#
  30hotpluggable_cpus()
  31{
  32        local state=${1:-.\*}
  33
  34        for cpu in $SYSFS/devices/system/cpu/cpu*; do
  35                if [ -f $cpu/online ] && grep -q $state $cpu/online; then
  36                        echo ${cpu##/*/cpu}
  37                fi
  38        done
  39}
  40
  41hotplaggable_offline_cpus()
  42{
  43        hotpluggable_cpus 0
  44}
  45
  46hotpluggable_online_cpus()
  47{
  48        hotpluggable_cpus 1
  49}
  50
  51cpu_is_online()
  52{
  53        grep -q 1 $SYSFS/devices/system/cpu/cpu$1/online
  54}
  55
  56cpu_is_offline()
  57{
  58        grep -q 0 $SYSFS/devices/system/cpu/cpu$1/online
  59}
  60
  61online_cpu()
  62{
  63        echo 1 > $SYSFS/devices/system/cpu/cpu$1/online
  64}
  65
  66offline_cpu()
  67{
  68        echo 0 > $SYSFS/devices/system/cpu/cpu$1/online
  69}
  70
  71online_cpu_expect_success()
  72{
  73        local cpu=$1
  74
  75        if ! online_cpu $cpu; then
  76                echo $FUNCNAME $cpu: unexpected fail >&2
  77        elif ! cpu_is_online $cpu; then
  78                echo $FUNCNAME $cpu: unexpected offline >&2
  79        fi
  80}
  81
  82online_cpu_expect_fail()
  83{
  84        local cpu=$1
  85
  86        if online_cpu $cpu 2> /dev/null; then
  87                echo $FUNCNAME $cpu: unexpected success >&2
  88        elif ! cpu_is_offline $cpu; then
  89                echo $FUNCNAME $cpu: unexpected online >&2
  90        fi
  91}
  92
  93offline_cpu_expect_success()
  94{
  95        local cpu=$1
  96
  97        if ! offline_cpu $cpu; then
  98                echo $FUNCNAME $cpu: unexpected fail >&2
  99        elif ! cpu_is_offline $cpu; then
 100                echo $FUNCNAME $cpu: unexpected offline >&2
 101        fi
 102}
 103
 104offline_cpu_expect_fail()
 105{
 106        local cpu=$1
 107
 108        if offline_cpu $cpu 2> /dev/null; then
 109                echo $FUNCNAME $cpu: unexpected success >&2
 110        elif ! cpu_is_online $cpu; then
 111                echo $FUNCNAME $cpu: unexpected offline >&2
 112        fi
 113}
 114
 115error=-12
 116priority=0
 117
 118while getopts e:hp: opt; do
 119        case $opt in
 120        e)
 121                error=$OPTARG
 122                ;;
 123        h)
 124                echo "Usage $0 [ -e errno ] [ -p notifier-priority ]"
 125                exit
 126                ;;
 127        p)
 128                priority=$OPTARG
 129                ;;
 130        esac
 131done
 132
 133if ! [ "$error" -ge -4095 -a "$error" -lt 0 ]; then
 134        echo "error code must be -4095 <= errno < 0" >&2
 135        exit 1
 136fi
 137
 138prerequisite
 139
 140#
 141# Online all hot-pluggable CPUs
 142#
 143for cpu in `hotplaggable_offline_cpus`; do
 144        online_cpu_expect_success $cpu
 145done
 146
 147#
 148# Offline all hot-pluggable CPUs
 149#
 150for cpu in `hotpluggable_online_cpus`; do
 151        offline_cpu_expect_success $cpu
 152done
 153
 154#
 155# Online all hot-pluggable CPUs again
 156#
 157for cpu in `hotplaggable_offline_cpus`; do
 158        online_cpu_expect_success $cpu
 159done
 160
 161#
 162# Test with cpu notifier error injection
 163#
 164
 165DEBUGFS=`mount -t debugfs | head -1 | awk '{ print $3 }'`
 166NOTIFIER_ERR_INJECT_DIR=$DEBUGFS/notifier-error-inject/cpu
 167
 168prerequisite_extra()
 169{
 170        msg="skip extra tests:"
 171
 172        /sbin/modprobe -q -r cpu-notifier-error-inject
 173        /sbin/modprobe -q cpu-notifier-error-inject priority=$priority
 174
 175        if [ ! -d "$DEBUGFS" ]; then
 176                echo $msg debugfs is not mounted >&2
 177                exit 0
 178        fi
 179
 180        if [ ! -d $NOTIFIER_ERR_INJECT_DIR ]; then
 181                echo $msg cpu-notifier-error-inject module is not available >&2
 182                exit 0
 183        fi
 184}
 185
 186prerequisite_extra
 187
 188#
 189# Offline all hot-pluggable CPUs
 190#
 191echo 0 > $NOTIFIER_ERR_INJECT_DIR/actions/CPU_DOWN_PREPARE/error
 192for cpu in `hotpluggable_online_cpus`; do
 193        offline_cpu_expect_success $cpu
 194done
 195
 196#
 197# Test CPU hot-add error handling (offline => online)
 198#
 199echo $error > $NOTIFIER_ERR_INJECT_DIR/actions/CPU_UP_PREPARE/error
 200for cpu in `hotplaggable_offline_cpus`; do
 201        online_cpu_expect_fail $cpu
 202done
 203
 204#
 205# Online all hot-pluggable CPUs
 206#
 207echo 0 > $NOTIFIER_ERR_INJECT_DIR/actions/CPU_UP_PREPARE/error
 208for cpu in `hotplaggable_offline_cpus`; do
 209        online_cpu_expect_success $cpu
 210done
 211
 212#
 213# Test CPU hot-remove error handling (online => offline)
 214#
 215echo $error > $NOTIFIER_ERR_INJECT_DIR/actions/CPU_DOWN_PREPARE/error
 216for cpu in `hotpluggable_online_cpus`; do
 217        offline_cpu_expect_fail $cpu
 218done
 219
 220echo 0 > $NOTIFIER_ERR_INJECT_DIR/actions/CPU_DOWN_PREPARE/error
 221/sbin/modprobe -q -r cpu-notifier-error-inject
 222